# In SUNSET decadal loading, we try to use several "_depends = 'var'" and it works.

test_that("multiple depends on var", {

suppressWarnings(
data <- Start(dat = "/esarchive//exp/canesm5/cmip6-dcppA-hindcast/original_files/cmorfiles/DCPP/CCCma/CanESM5/dcppA-hindcast//$ensemble$/$table$/$var$/$grid$/$version$/$var$_$table$_*_dcppA-hindcast_s$syear$-$ensemble$_$grid$_$chunk$.nc",
              var = c('tas', 'tos'),
              syear = paste(1990:1992),
              chunk = 'all',
              chunk_depends = 'syear',
              time = indices(1:13),
              time_across = 'chunk',
              merge_across_dims = TRUE,
              latitude = values(list(10,12)),
              latitude_reorder = Sort(),
              longitude = values(list(160:162)),
              longitude_reorder = CircularSort(0, 360),
              ensemble = c("r1i1p2f1", "r2i1p2f1", "r3i1p2f1"),
              synonims = list(longitude = c('longitude', 'lon'), latitude = c('latitude', 'lat')),
              return_vars = list(latitude = NULL, longitude = NULL, time = c('syear', 'chunk')),
              retrieve = TRUE,
              table = list(tas = 'Amon', tos = 'Omon'),
              grid = list(tas = 'gn', tos = 'gr'),
              version = list(tas = 'v20190429', tos = 'v20190429'),
              table_depends = 'var',
              grid_depends = 'var',
              version_depends = 'var',
              metadata_dims = 'var')
)

suppressWarnings(
data_tas <- Start(dat = "/esarchive//exp/canesm5/cmip6-dcppA-hindcast/original_files/cmorfiles/DCPP/CCCma/CanESM5/dcppA-hindcast//$ensemble$/$table$/$var$/$grid$/$version$/$var$_$table$_*_dcppA-hindcast_s$syear$-$ensemble$_$grid$_$chunk$.nc",
              var = c('tas', 'tos')[1],
              syear = paste(1990:1992),
              chunk = 'all',
              chunk_depends = 'syear',
              time = indices(1:13),
              time_across = 'chunk',
              merge_across_dims = TRUE,
              latitude = values(list(10,12)),
              latitude_reorder = Sort(),
              longitude = values(list(160:162)),
              longitude_reorder = CircularSort(0, 360),
              ensemble = c("r1i1p2f1", "r2i1p2f1", "r3i1p2f1"),
              synonims = list(longitude = c('longitude', 'lon'), latitude = c('latitude', 'lat')),
              return_vars = list(latitude = NULL, longitude = NULL, time = c('syear', 'chunk')),
              retrieve = TRUE, grid = 'gn', version = 'v20190429', table = 'Amon')
)

suppressWarnings(
data_tos <- Start(dat = "/esarchive//exp/canesm5/cmip6-dcppA-hindcast/original_files/cmorfiles/DCPP/CCCma/CanESM5/dcppA-hindcast//$ensemble$/$table$/$var$/$grid$/$version$/$var$_$table$_*_dcppA-hindcast_s$syear$-$ensemble$_$grid$_$chunk$.nc",
              var = c('tas', 'tos')[2],
              syear = paste(1990:1992),
              chunk = 'all',
              chunk_depends = 'syear',
              time = indices(1:13),
              time_across = 'chunk',
              merge_across_dims = TRUE,
              latitude = values(list(10,12)),
              latitude_reorder = Sort(),
              longitude = values(list(160:162)),
              longitude_reorder = CircularSort(0, 360),
              ensemble = c("r1i1p2f1", "r2i1p2f1", "r3i1p2f1"),
              synonims = list(longitude = c('longitude', 'lon'), latitude = c('latitude', 'lat')),
              return_vars = list(latitude = NULL, longitude = NULL, time = c('syear', 'chunk')),
              retrieve = TRUE, grid = 'gr', version = 'v20190429', table = 'Omon')
)

expect_equal(
dim(data),
c(dat = 1, var = 2, syear = 3, time = 13, latitude = 2, longitude = 3, ensemble = 3, table = 1, grid = 1, version = 1) 
)
expect_equal(
identical(c(data_tas), c(data[1,1,,,,,,1,1,1])),
TRUE
)
expect_equal(
identical(c(data_tos), c(data[1,2,,,,,,1,1,1])),
TRUE
)
expect_equal(
names(attributes(data)$Variables$common),
c("latitude", "longitude", "time", "tas", "tos")
)
expect_equal(
attributes(data)$Variables$common$tas,
attributes(data_tas)$Variables$common$tas
)
expect_equal(
attributes(data)$Variables$common$tos,
attributes(data_tos)$Variables$common$tos
)

})
